// (c) Copyright 2013 Cloudera, Inc. All rights reserved.

define(["cloudera/cmf/charts/SelectMetricDialog","cloudera/Util","underscore"],function(e,t,n){describe("SelectMetricDialog",function(){var t,r,i=function(){return{cdh3:{cpu_system:{name:"Current System CPUs",description:"Kernel CPU time used (CPUs / s)"},cpu_user:{name:"Current User CPUs",description:"Current User CPUs"}},cdh4:{cpu_user:{name:"Current User CPUs",description:"Current User CPUs"},data_local_maps:{name:"Data-local maps",description:"Number of map tasks reading local data"},disk_read:{name:"Cumulative disk reads",description:"Reads from local disk (bytes)"}}}},s=function(e){return{name:e.toUpperCase()+" display name",description:e+" description"}};beforeEach(function(){r={metrics:{}},t=new e(r)}),it("has sane properties",function(){expect(t.metrics().length).toEqual(0),expect(t.entities().length).toEqual(0),expect(t.filterText()).toEqual(null)}),it("can transform server response into list of entities",function(){var e={ENTITY1:i(),ENTITY2:i()};t.createEntities(e);var n=t.entities();expect(n.length).toEqual(2);var r=n[0];expect(r.metrics.length).toEqual(4);var s=r.metrics[0];expect(s.name).toEqual("disk_read"),expect(s.displayName).toEqual("Cumulative disk reads"),expect(s.description).toEqual("Reads from local disk (bytes)"),expect(r.metrics[1].name).toEqual("cpu_system"),expect(r.metrics[2].name).toEqual("cpu_user"),expect(r.metrics[3].name).toEqual("data_local_maps")}),it("skips certain entities when transforming metrics",function(){var e={ACTIVITY:i(),ATTEMPT:i(),CLUSTER:i(),Activity:i(),attEmpt:i(),ENTITY1:i()};t.createEntities(e);var n=t.entities();expect(n.length).toEqual(2),expect(n[0].name).toEqual("CLUSTER"),expect(n[1].name).toEqual("ENTITY1")}),it("shows supported versions of the metrics",function(){var e=function(e,t){return n.find(e.metrics,function(e){return e.name===t})},r={ENTITY1:i(),ENTITY2:i()};t.createEntities(r);var s=t.entities()[0],o=e(s,"cpu_system");expect(o.versions).toBeDefined(),expect(o.versions.length).toEqual(1),expect(o.versions[0]).toEqual("cdh3");var u=e(s,"cpu_user");expect(u.versions).toBeDefined(),expect(u.versions.length).toEqual(2),expect(u.versions[0]).toEqual("cdh3"),expect(u.versions[1]).toEqual("cdh4")}),it('adds "enterprise" versions',function(){var e={ENTITY1:{enterprise:{fake_metric:{name:"Fake Metric",description:"This is a fake metric."}}}};t.createEntities(e);var n=t.entities()[0],r=n.metrics[0];expect(r.versions).toBeDefined(),expect(r.versions.length).toEqual(1)}),describe("metric filtering",function(){it("can check metrics against a filter",function(){var e={ENTITY:i()};t.createEntities(e);var n=t.entities()[0],r=n.metrics[0];expect(r.name).toEqual("disk_read"),t.filterText(),expect(t.isMatch(r)).toBeTruthy(),t.filterText("d"),expect(t.isMatch(r)).toBeTruthy(),t.filterText("di"),expect(t.isMatch(r)).toBeTruthy(),t.filterText("dis"),expect(t.isMatch(r)).toBeTruthy(),t.filterText("k_r"),expect(t.isMatch(r)).toBeTruthy(),t.filterText("x"),expect(t.isMatch(r)).toBeFalsy(),t.filterText("catpants"),expect(t.isMatch(r)).toBeFalsy()}),it("can filter cdh3 and cdh4 metrics out",function(){var e={ENTITY:{cdh3:{metric1:s("metric1"),metric2:s("metric2")},cdh4:{metric2:s("metric2")}}};t.createEntities(e);var n=t.entities()[0],r=n.filteredMetrics();expect(r.length).toEqual(2),expect(r[0].name).toEqual("metric1"),expect(r[1].name).toEqual("metric2"),t.showCDH3(!1),r=n.filteredMetrics(),expect(r.length).toEqual(1),expect(r[0].name).toEqual("metric2"),t.showCDH4(!1),r=n.filteredMetrics(),expect(r.length).toEqual(0)}),it("can filter out aggregate metrics",function(){var e={ENTITY:{cdh4:{metric1:s("metric1"),metric2:s("metric2")}}};e.ENTITY.cdh4.metric1.isAggregate=!0,t.createEntities(e);var n=t.entities()[0],r=n.filteredMetrics();expect(r.length).toEqual(1),expect(r[0].name).toEqual("metric2"),t.showAggregateMetrics(!0),r=n.filteredMetrics(),expect(r.length).toEqual(2),expect(r[0].name).toEqual("metric1"),expect(r[1].name).toEqual("metric2")})}),describe("entity filtering",function(){beforeEach(function(){var e={ENTITY1:{enterprise:{aa:s("aa"),ba:s("ba")}},ENTITY2:{enterprise:{ab:s("aa"),bb:s("bb"),ca:s("cb")}},ENTITY3:{enterprise:{ca:s("cb")}}};t.createEntities(e)}),it("can filter entities on the metric name",function(){expect(t.entities().length).toEqual(t.filteredEntities().length),t.filterText("aa");var e=t.filteredEntities();expect(e.length).toEqual(2),expect(e[0].name).toEqual("ENTITY1"),expect(e[1].name).toEqual("ENTITY2"),t.filterText("cb"),e=t.filteredEntities(),expect(e.length).toEqual(2),expect(e[0].name).toEqual("ENTITY2"),expect(e[1].name).toEqual("ENTITY3")}),it("can filter entities on the metric description",function(){expect(t.entities().length).toEqual(t.filteredEntities().length),t.filterText("aa description");var e=t.filteredEntities();expect(e.length).toEqual(2),expect(e[0].name).toEqual("ENTITY1"),expect(e[1].name).toEqual("ENTITY2")}),it("can filter entities on the metric display name",function(){expect(t.entities().length).toEqual(t.filteredEntities().length),t.filterText("cb display");var e=t.filteredEntities();expect(e.length).toEqual(2),expect(e[0].name).toEqual("ENTITY2"),expect(e[1].name).toEqual("ENTITY3"),console.groupEnd()})})})})